# coding=utf-8
from connect import connection, engine, metadata
import sqlalchemy as db
from flask import jsonify, redirect, url_for, render_template
import json
# import index.py
from funciones import valida_fecha

col1=[{"label":"Acciones","type":"text","name":"acciones","require":"1"}]
col2=[{"label":"Razon","type":"text","name":"razon","require":"1"}]
form_order= {"entradas":{"col1":col1,"col2":col2}}
visita_col=["Razon", "Acciones"]

def prepara_values_usuario(data):
	pass

def prepara_values_enfermera(data):
	pass

def edit(data):
	pass

def add(data):
	pass


def add_form():
	i=1
	orden=1
	entradas={}
	for col in form_order["entradas"]:
		col_data=[]
		for item in form_order["entradas"][col]:
			item.update({"tabindex":orden})
			item.update({"disabled":False})
			orden+=1
		entradas.update({"col"+str(i):col_data})
		i+=1
	data= {"titulo":"Enfermera","accion":"Añadir"}
	data.update(form_order)
	data.update({"abled":True})
	return jsonify(data)

def edit_form(id, disabled=False):
	visitas_enfermeria = db.Table('visitas_enfermeria', metadata, autoload=True, autoload_with=engine)
	query = db.select([visitas_enfermeria.columns.razon, visitas_enfermeria.columns.acciones])
	query = query.select_from(visitas_enfermeria).where(visitas_enfermeria.columns.id == id)
	result = connection.execute(query).fetchall()
	if not len(result):
		return False
	for row in result:
		row_as_dict = dict(row)
	i=1
	orden=1
	entradas={}
	for col in form_order["entradas"]:
		col_data=[]
		for item in form_order["entradas"][col]:
			if item["type"]=="select":
				item.update({"value":{"id":row_as_dict[item["name"]]}})
			elif item["type"]=="checkbox":
				item.update({"value":int(row_as_dict[item["name"]])})
			else:
				item.update({"value":str(row_as_dict[item["name"]])})
			item.update({"tabindex":orden})
			item.update({"disabled":disabled})
			col_data.append(item)
			orden+=1
		entradas.update({"col"+str(i):col_data})
		i+=1
	data= {"titulo":"Visitas Enfermeria","accion":"Editar"}
	data.update({"entradas":entradas})
	abled=True
	if disabled:
		abled=False
	data.update({"abled":abled})
	return jsonify(data)
